// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: accelfin-server-demo-fx-dtos.proto

package com.accelfin.server.demo.fx.dtos;

/**
 * Protobuf type {@code com.accelfin.server.demo.fx.dtos.FxSpotPriceDto}
 */
public  final class FxSpotPriceDto extends
    com.google.protobuf.GeneratedMessage implements
    // @@protoc_insertion_point(message_implements:com.accelfin.server.demo.fx.dtos.FxSpotPriceDto)
    FxSpotPriceDtoOrBuilder {
  // Use FxSpotPriceDto.newBuilder() to construct.
  private FxSpotPriceDto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
    super(builder);
  }
  private FxSpotPriceDto() {
    id_ = "";
    symbol_ = "";
    isTradable_ = false;
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
  }
  private FxSpotPriceDto(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    int mutable_bitField0_ = 0;
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!input.skipField(tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            java.lang.String s = input.readStringRequireUtf8();

            id_ = s;
            break;
          }
          case 18: {
            java.lang.String s = input.readStringRequireUtf8();

            symbol_ = s;
            break;
          }
          case 26: {
            com.accelfin.server.messaging.dtos.TimestampDto.Builder subBuilder = null;
            if (spotDate_ != null) {
              subBuilder = spotDate_.toBuilder();
            }
            spotDate_ = input.readMessage(com.accelfin.server.messaging.dtos.TimestampDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(spotDate_);
              spotDate_ = subBuilder.buildPartial();
            }

            break;
          }
          case 34: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (mid_ != null) {
              subBuilder = mid_.toBuilder();
            }
            mid_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(mid_);
              mid_ = subBuilder.buildPartial();
            }

            break;
          }
          case 42: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (ask_ != null) {
              subBuilder = ask_.toBuilder();
            }
            ask_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(ask_);
              ask_ = subBuilder.buildPartial();
            }

            break;
          }
          case 50: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (bid_ != null) {
              subBuilder = bid_.toBuilder();
            }
            bid_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(bid_);
              bid_ = subBuilder.buildPartial();
            }

            break;
          }
          case 58: {
            com.accelfin.server.messaging.dtos.DecimalDto.Builder subBuilder = null;
            if (spread_ != null) {
              subBuilder = spread_.toBuilder();
            }
            spread_ = input.readMessage(com.accelfin.server.messaging.dtos.DecimalDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(spread_);
              spread_ = subBuilder.buildPartial();
            }

            break;
          }
          case 66: {
            com.accelfin.server.messaging.dtos.TimestampDto.Builder subBuilder = null;
            if (creationDate_ != null) {
              subBuilder = creationDate_.toBuilder();
            }
            creationDate_ = input.readMessage(com.accelfin.server.messaging.dtos.TimestampDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(creationDate_);
              creationDate_ = subBuilder.buildPartial();
            }

            break;
          }
          case 72: {

            isTradable_ = input.readBool();
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_FxSpotPriceDto_descriptor;
  }

  protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_FxSpotPriceDto_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.accelfin.server.demo.fx.dtos.FxSpotPriceDto.class, com.accelfin.server.demo.fx.dtos.FxSpotPriceDto.Builder.class);
  }

  public static final int ID_FIELD_NUMBER = 1;
  private volatile java.lang.Object id_;
  /**
   * <code>optional string id = 1;</code>
   */
  public java.lang.String getId() {
    java.lang.Object ref = id_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      id_ = s;
      return s;
    }
  }
  /**
   * <code>optional string id = 1;</code>
   */
  public com.google.protobuf.ByteString
      getIdBytes() {
    java.lang.Object ref = id_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      id_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int SYMBOL_FIELD_NUMBER = 2;
  private volatile java.lang.Object symbol_;
  /**
   * <code>optional string symbol = 2;</code>
   */
  public java.lang.String getSymbol() {
    java.lang.Object ref = symbol_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      symbol_ = s;
      return s;
    }
  }
  /**
   * <code>optional string symbol = 2;</code>
   */
  public com.google.protobuf.ByteString
      getSymbolBytes() {
    java.lang.Object ref = symbol_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      symbol_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int SPOT_DATE_FIELD_NUMBER = 3;
  private com.accelfin.server.messaging.dtos.TimestampDto spotDate_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
   */
  public boolean hasSpotDate() {
    return spotDate_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDto getSpotDate() {
    return spotDate_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : spotDate_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getSpotDateOrBuilder() {
    return getSpotDate();
  }

  public static final int MID_FIELD_NUMBER = 4;
  private com.accelfin.server.messaging.dtos.DecimalDto mid_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
   */
  public boolean hasMid() {
    return mid_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getMid() {
    return mid_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : mid_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getMidOrBuilder() {
    return getMid();
  }

  public static final int ASK_FIELD_NUMBER = 5;
  private com.accelfin.server.messaging.dtos.DecimalDto ask_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
   */
  public boolean hasAsk() {
    return ask_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getAsk() {
    return ask_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : ask_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getAskOrBuilder() {
    return getAsk();
  }

  public static final int BID_FIELD_NUMBER = 6;
  private com.accelfin.server.messaging.dtos.DecimalDto bid_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
   */
  public boolean hasBid() {
    return bid_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getBid() {
    return bid_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : bid_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getBidOrBuilder() {
    return getBid();
  }

  public static final int SPREAD_FIELD_NUMBER = 7;
  private com.accelfin.server.messaging.dtos.DecimalDto spread_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
   */
  public boolean hasSpread() {
    return spread_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDto getSpread() {
    return spread_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : spread_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
   */
  public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getSpreadOrBuilder() {
    return getSpread();
  }

  public static final int CREATION_DATE_FIELD_NUMBER = 8;
  private com.accelfin.server.messaging.dtos.TimestampDto creationDate_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
   */
  public boolean hasCreationDate() {
    return creationDate_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDto getCreationDate() {
    return creationDate_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : creationDate_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getCreationDateOrBuilder() {
    return getCreationDate();
  }

  public static final int IS_TRADABLE_FIELD_NUMBER = 9;
  private boolean isTradable_;
  /**
   * <code>optional bool is_tradable = 9;</code>
   */
  public boolean getIsTradable() {
    return isTradable_;
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!getIdBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessage.writeString(output, 1, id_);
    }
    if (!getSymbolBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessage.writeString(output, 2, symbol_);
    }
    if (spotDate_ != null) {
      output.writeMessage(3, getSpotDate());
    }
    if (mid_ != null) {
      output.writeMessage(4, getMid());
    }
    if (ask_ != null) {
      output.writeMessage(5, getAsk());
    }
    if (bid_ != null) {
      output.writeMessage(6, getBid());
    }
    if (spread_ != null) {
      output.writeMessage(7, getSpread());
    }
    if (creationDate_ != null) {
      output.writeMessage(8, getCreationDate());
    }
    if (isTradable_ != false) {
      output.writeBool(9, isTradable_);
    }
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getIdBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(1, id_);
    }
    if (!getSymbolBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(2, symbol_);
    }
    if (spotDate_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getSpotDate());
    }
    if (mid_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getMid());
    }
    if (ask_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getAsk());
    }
    if (bid_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getBid());
    }
    if (spread_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, getSpread());
    }
    if (creationDate_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(8, getCreationDate());
    }
    if (isTradable_ != false) {
      size += com.google.protobuf.CodedOutputStream
        .computeBoolSize(9, isTradable_);
    }
    memoizedSize = size;
    return size;
  }

  private static final long serialVersionUID = 0L;
  public static com.accelfin.server.demo.fx.dtos.FxSpotPriceDto parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.FxSpotPriceDto parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.FxSpotPriceDto parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.FxSpotPriceDto parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.FxSpotPriceDto parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.FxSpotPriceDto parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.FxSpotPriceDto parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.FxSpotPriceDto parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.FxSpotPriceDto parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.FxSpotPriceDto parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.accelfin.server.demo.fx.dtos.FxSpotPriceDto prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessage.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code com.accelfin.server.demo.fx.dtos.FxSpotPriceDto}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessage.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:com.accelfin.server.demo.fx.dtos.FxSpotPriceDto)
      com.accelfin.server.demo.fx.dtos.FxSpotPriceDtoOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_FxSpotPriceDto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_FxSpotPriceDto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.accelfin.server.demo.fx.dtos.FxSpotPriceDto.class, com.accelfin.server.demo.fx.dtos.FxSpotPriceDto.Builder.class);
    }

    // Construct using com.accelfin.server.demo.fx.dtos.FxSpotPriceDto.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
      }
    }
    public Builder clear() {
      super.clear();
      id_ = "";

      symbol_ = "";

      if (spotDateBuilder_ == null) {
        spotDate_ = null;
      } else {
        spotDate_ = null;
        spotDateBuilder_ = null;
      }
      if (midBuilder_ == null) {
        mid_ = null;
      } else {
        mid_ = null;
        midBuilder_ = null;
      }
      if (askBuilder_ == null) {
        ask_ = null;
      } else {
        ask_ = null;
        askBuilder_ = null;
      }
      if (bidBuilder_ == null) {
        bid_ = null;
      } else {
        bid_ = null;
        bidBuilder_ = null;
      }
      if (spreadBuilder_ == null) {
        spread_ = null;
      } else {
        spread_ = null;
        spreadBuilder_ = null;
      }
      if (creationDateBuilder_ == null) {
        creationDate_ = null;
      } else {
        creationDate_ = null;
        creationDateBuilder_ = null;
      }
      isTradable_ = false;

      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_FxSpotPriceDto_descriptor;
    }

    public com.accelfin.server.demo.fx.dtos.FxSpotPriceDto getDefaultInstanceForType() {
      return com.accelfin.server.demo.fx.dtos.FxSpotPriceDto.getDefaultInstance();
    }

    public com.accelfin.server.demo.fx.dtos.FxSpotPriceDto build() {
      com.accelfin.server.demo.fx.dtos.FxSpotPriceDto result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public com.accelfin.server.demo.fx.dtos.FxSpotPriceDto buildPartial() {
      com.accelfin.server.demo.fx.dtos.FxSpotPriceDto result = new com.accelfin.server.demo.fx.dtos.FxSpotPriceDto(this);
      result.id_ = id_;
      result.symbol_ = symbol_;
      if (spotDateBuilder_ == null) {
        result.spotDate_ = spotDate_;
      } else {
        result.spotDate_ = spotDateBuilder_.build();
      }
      if (midBuilder_ == null) {
        result.mid_ = mid_;
      } else {
        result.mid_ = midBuilder_.build();
      }
      if (askBuilder_ == null) {
        result.ask_ = ask_;
      } else {
        result.ask_ = askBuilder_.build();
      }
      if (bidBuilder_ == null) {
        result.bid_ = bid_;
      } else {
        result.bid_ = bidBuilder_.build();
      }
      if (spreadBuilder_ == null) {
        result.spread_ = spread_;
      } else {
        result.spread_ = spreadBuilder_.build();
      }
      if (creationDateBuilder_ == null) {
        result.creationDate_ = creationDate_;
      } else {
        result.creationDate_ = creationDateBuilder_.build();
      }
      result.isTradable_ = isTradable_;
      onBuilt();
      return result;
    }

    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.accelfin.server.demo.fx.dtos.FxSpotPriceDto) {
        return mergeFrom((com.accelfin.server.demo.fx.dtos.FxSpotPriceDto)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.accelfin.server.demo.fx.dtos.FxSpotPriceDto other) {
      if (other == com.accelfin.server.demo.fx.dtos.FxSpotPriceDto.getDefaultInstance()) return this;
      if (!other.getId().isEmpty()) {
        id_ = other.id_;
        onChanged();
      }
      if (!other.getSymbol().isEmpty()) {
        symbol_ = other.symbol_;
        onChanged();
      }
      if (other.hasSpotDate()) {
        mergeSpotDate(other.getSpotDate());
      }
      if (other.hasMid()) {
        mergeMid(other.getMid());
      }
      if (other.hasAsk()) {
        mergeAsk(other.getAsk());
      }
      if (other.hasBid()) {
        mergeBid(other.getBid());
      }
      if (other.hasSpread()) {
        mergeSpread(other.getSpread());
      }
      if (other.hasCreationDate()) {
        mergeCreationDate(other.getCreationDate());
      }
      if (other.getIsTradable() != false) {
        setIsTradable(other.getIsTradable());
      }
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      com.accelfin.server.demo.fx.dtos.FxSpotPriceDto parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (com.accelfin.server.demo.fx.dtos.FxSpotPriceDto) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private java.lang.Object id_ = "";
    /**
     * <code>optional string id = 1;</code>
     */
    public java.lang.String getId() {
      java.lang.Object ref = id_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        id_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>optional string id = 1;</code>
     */
    public com.google.protobuf.ByteString
        getIdBytes() {
      java.lang.Object ref = id_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        id_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>optional string id = 1;</code>
     */
    public Builder setId(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      id_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional string id = 1;</code>
     */
    public Builder clearId() {
      
      id_ = getDefaultInstance().getId();
      onChanged();
      return this;
    }
    /**
     * <code>optional string id = 1;</code>
     */
    public Builder setIdBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      id_ = value;
      onChanged();
      return this;
    }

    private java.lang.Object symbol_ = "";
    /**
     * <code>optional string symbol = 2;</code>
     */
    public java.lang.String getSymbol() {
      java.lang.Object ref = symbol_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        symbol_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>optional string symbol = 2;</code>
     */
    public com.google.protobuf.ByteString
        getSymbolBytes() {
      java.lang.Object ref = symbol_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        symbol_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>optional string symbol = 2;</code>
     */
    public Builder setSymbol(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      symbol_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional string symbol = 2;</code>
     */
    public Builder clearSymbol() {
      
      symbol_ = getDefaultInstance().getSymbol();
      onChanged();
      return this;
    }
    /**
     * <code>optional string symbol = 2;</code>
     */
    public Builder setSymbolBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      symbol_ = value;
      onChanged();
      return this;
    }

    private com.accelfin.server.messaging.dtos.TimestampDto spotDate_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> spotDateBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
     */
    public boolean hasSpotDate() {
      return spotDateBuilder_ != null || spotDate_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto getSpotDate() {
      if (spotDateBuilder_ == null) {
        return spotDate_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : spotDate_;
      } else {
        return spotDateBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
     */
    public Builder setSpotDate(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (spotDateBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        spotDate_ = value;
        onChanged();
      } else {
        spotDateBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
     */
    public Builder setSpotDate(
        com.accelfin.server.messaging.dtos.TimestampDto.Builder builderForValue) {
      if (spotDateBuilder_ == null) {
        spotDate_ = builderForValue.build();
        onChanged();
      } else {
        spotDateBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
     */
    public Builder mergeSpotDate(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (spotDateBuilder_ == null) {
        if (spotDate_ != null) {
          spotDate_ =
            com.accelfin.server.messaging.dtos.TimestampDto.newBuilder(spotDate_).mergeFrom(value).buildPartial();
        } else {
          spotDate_ = value;
        }
        onChanged();
      } else {
        spotDateBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
     */
    public Builder clearSpotDate() {
      if (spotDateBuilder_ == null) {
        spotDate_ = null;
        onChanged();
      } else {
        spotDate_ = null;
        spotDateBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto.Builder getSpotDateBuilder() {
      
      onChanged();
      return getSpotDateFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getSpotDateOrBuilder() {
      if (spotDateBuilder_ != null) {
        return spotDateBuilder_.getMessageOrBuilder();
      } else {
        return spotDate_ == null ?
            com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : spotDate_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto spot_date = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> 
        getSpotDateFieldBuilder() {
      if (spotDateBuilder_ == null) {
        spotDateBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder>(
                getSpotDate(),
                getParentForChildren(),
                isClean());
        spotDate_ = null;
      }
      return spotDateBuilder_;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto mid_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> midBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
     */
    public boolean hasMid() {
      return midBuilder_ != null || mid_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getMid() {
      if (midBuilder_ == null) {
        return mid_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : mid_;
      } else {
        return midBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
     */
    public Builder setMid(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (midBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        mid_ = value;
        onChanged();
      } else {
        midBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
     */
    public Builder setMid(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (midBuilder_ == null) {
        mid_ = builderForValue.build();
        onChanged();
      } else {
        midBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
     */
    public Builder mergeMid(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (midBuilder_ == null) {
        if (mid_ != null) {
          mid_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(mid_).mergeFrom(value).buildPartial();
        } else {
          mid_ = value;
        }
        onChanged();
      } else {
        midBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
     */
    public Builder clearMid() {
      if (midBuilder_ == null) {
        mid_ = null;
        onChanged();
      } else {
        mid_ = null;
        midBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getMidBuilder() {
      
      onChanged();
      return getMidFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getMidOrBuilder() {
      if (midBuilder_ != null) {
        return midBuilder_.getMessageOrBuilder();
      } else {
        return mid_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : mid_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto mid = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getMidFieldBuilder() {
      if (midBuilder_ == null) {
        midBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getMid(),
                getParentForChildren(),
                isClean());
        mid_ = null;
      }
      return midBuilder_;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto ask_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> askBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
     */
    public boolean hasAsk() {
      return askBuilder_ != null || ask_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getAsk() {
      if (askBuilder_ == null) {
        return ask_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : ask_;
      } else {
        return askBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
     */
    public Builder setAsk(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (askBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ask_ = value;
        onChanged();
      } else {
        askBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
     */
    public Builder setAsk(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (askBuilder_ == null) {
        ask_ = builderForValue.build();
        onChanged();
      } else {
        askBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
     */
    public Builder mergeAsk(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (askBuilder_ == null) {
        if (ask_ != null) {
          ask_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(ask_).mergeFrom(value).buildPartial();
        } else {
          ask_ = value;
        }
        onChanged();
      } else {
        askBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
     */
    public Builder clearAsk() {
      if (askBuilder_ == null) {
        ask_ = null;
        onChanged();
      } else {
        ask_ = null;
        askBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getAskBuilder() {
      
      onChanged();
      return getAskFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getAskOrBuilder() {
      if (askBuilder_ != null) {
        return askBuilder_.getMessageOrBuilder();
      } else {
        return ask_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : ask_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto ask = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getAskFieldBuilder() {
      if (askBuilder_ == null) {
        askBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getAsk(),
                getParentForChildren(),
                isClean());
        ask_ = null;
      }
      return askBuilder_;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto bid_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> bidBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
     */
    public boolean hasBid() {
      return bidBuilder_ != null || bid_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getBid() {
      if (bidBuilder_ == null) {
        return bid_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : bid_;
      } else {
        return bidBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
     */
    public Builder setBid(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (bidBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        bid_ = value;
        onChanged();
      } else {
        bidBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
     */
    public Builder setBid(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (bidBuilder_ == null) {
        bid_ = builderForValue.build();
        onChanged();
      } else {
        bidBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
     */
    public Builder mergeBid(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (bidBuilder_ == null) {
        if (bid_ != null) {
          bid_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(bid_).mergeFrom(value).buildPartial();
        } else {
          bid_ = value;
        }
        onChanged();
      } else {
        bidBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
     */
    public Builder clearBid() {
      if (bidBuilder_ == null) {
        bid_ = null;
        onChanged();
      } else {
        bid_ = null;
        bidBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getBidBuilder() {
      
      onChanged();
      return getBidFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getBidOrBuilder() {
      if (bidBuilder_ != null) {
        return bidBuilder_.getMessageOrBuilder();
      } else {
        return bid_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : bid_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto bid = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getBidFieldBuilder() {
      if (bidBuilder_ == null) {
        bidBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getBid(),
                getParentForChildren(),
                isClean());
        bid_ = null;
      }
      return bidBuilder_;
    }

    private com.accelfin.server.messaging.dtos.DecimalDto spread_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> spreadBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
     */
    public boolean hasSpread() {
      return spreadBuilder_ != null || spread_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto getSpread() {
      if (spreadBuilder_ == null) {
        return spread_ == null ? com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : spread_;
      } else {
        return spreadBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
     */
    public Builder setSpread(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (spreadBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        spread_ = value;
        onChanged();
      } else {
        spreadBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
     */
    public Builder setSpread(
        com.accelfin.server.messaging.dtos.DecimalDto.Builder builderForValue) {
      if (spreadBuilder_ == null) {
        spread_ = builderForValue.build();
        onChanged();
      } else {
        spreadBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
     */
    public Builder mergeSpread(com.accelfin.server.messaging.dtos.DecimalDto value) {
      if (spreadBuilder_ == null) {
        if (spread_ != null) {
          spread_ =
            com.accelfin.server.messaging.dtos.DecimalDto.newBuilder(spread_).mergeFrom(value).buildPartial();
        } else {
          spread_ = value;
        }
        onChanged();
      } else {
        spreadBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
     */
    public Builder clearSpread() {
      if (spreadBuilder_ == null) {
        spread_ = null;
        onChanged();
      } else {
        spread_ = null;
        spreadBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDto.Builder getSpreadBuilder() {
      
      onChanged();
      return getSpreadFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder getSpreadOrBuilder() {
      if (spreadBuilder_ != null) {
        return spreadBuilder_.getMessageOrBuilder();
      } else {
        return spread_ == null ?
            com.accelfin.server.messaging.dtos.DecimalDto.getDefaultInstance() : spread_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.DecimalDto spread = 7;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder> 
        getSpreadFieldBuilder() {
      if (spreadBuilder_ == null) {
        spreadBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.DecimalDto, com.accelfin.server.messaging.dtos.DecimalDto.Builder, com.accelfin.server.messaging.dtos.DecimalDtoOrBuilder>(
                getSpread(),
                getParentForChildren(),
                isClean());
        spread_ = null;
      }
      return spreadBuilder_;
    }

    private com.accelfin.server.messaging.dtos.TimestampDto creationDate_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> creationDateBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
     */
    public boolean hasCreationDate() {
      return creationDateBuilder_ != null || creationDate_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto getCreationDate() {
      if (creationDateBuilder_ == null) {
        return creationDate_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : creationDate_;
      } else {
        return creationDateBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
     */
    public Builder setCreationDate(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (creationDateBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        creationDate_ = value;
        onChanged();
      } else {
        creationDateBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
     */
    public Builder setCreationDate(
        com.accelfin.server.messaging.dtos.TimestampDto.Builder builderForValue) {
      if (creationDateBuilder_ == null) {
        creationDate_ = builderForValue.build();
        onChanged();
      } else {
        creationDateBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
     */
    public Builder mergeCreationDate(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (creationDateBuilder_ == null) {
        if (creationDate_ != null) {
          creationDate_ =
            com.accelfin.server.messaging.dtos.TimestampDto.newBuilder(creationDate_).mergeFrom(value).buildPartial();
        } else {
          creationDate_ = value;
        }
        onChanged();
      } else {
        creationDateBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
     */
    public Builder clearCreationDate() {
      if (creationDateBuilder_ == null) {
        creationDate_ = null;
        onChanged();
      } else {
        creationDate_ = null;
        creationDateBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto.Builder getCreationDateBuilder() {
      
      onChanged();
      return getCreationDateFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getCreationDateOrBuilder() {
      if (creationDateBuilder_ != null) {
        return creationDateBuilder_.getMessageOrBuilder();
      } else {
        return creationDate_ == null ?
            com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : creationDate_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto creation_date = 8;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> 
        getCreationDateFieldBuilder() {
      if (creationDateBuilder_ == null) {
        creationDateBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder>(
                getCreationDate(),
                getParentForChildren(),
                isClean());
        creationDate_ = null;
      }
      return creationDateBuilder_;
    }

    private boolean isTradable_ ;
    /**
     * <code>optional bool is_tradable = 9;</code>
     */
    public boolean getIsTradable() {
      return isTradable_;
    }
    /**
     * <code>optional bool is_tradable = 9;</code>
     */
    public Builder setIsTradable(boolean value) {
      
      isTradable_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional bool is_tradable = 9;</code>
     */
    public Builder clearIsTradable() {
      
      isTradable_ = false;
      onChanged();
      return this;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }


    // @@protoc_insertion_point(builder_scope:com.accelfin.server.demo.fx.dtos.FxSpotPriceDto)
  }

  // @@protoc_insertion_point(class_scope:com.accelfin.server.demo.fx.dtos.FxSpotPriceDto)
  private static final com.accelfin.server.demo.fx.dtos.FxSpotPriceDto DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.accelfin.server.demo.fx.dtos.FxSpotPriceDto();
  }

  public static com.accelfin.server.demo.fx.dtos.FxSpotPriceDto getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<FxSpotPriceDto>
      PARSER = new com.google.protobuf.AbstractParser<FxSpotPriceDto>() {
    public FxSpotPriceDto parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
        return new FxSpotPriceDto(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<FxSpotPriceDto> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<FxSpotPriceDto> getParserForType() {
    return PARSER;
  }

  public com.accelfin.server.demo.fx.dtos.FxSpotPriceDto getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

